> ## Documentation Index
> Fetch the complete documentation index at: https://developer.affinity.co/llms.txt
> Use this file to discover all available pages before exploring further.

# Get all List Entries on a Saved View

> Paginate through the List Entries (AKA rows) on a given Saved View.
Use this endpoint when you need to filter entities or only want **some**
field data to be returned: This endpoint respects the filters set on a Saved View
via web app, and only returns field data corresponding to the columns that have been
pulled into the Saved View via web app.

Though this endpoint respects the Saved View's filters and column/Field selection,
it does not yet preserve sort order. This endpoint also only supports **sheet-type
Saved Views**, and not board- or dashboard-type Saved Views.

See the [Data Model](/pages/data-model/the-basics) section for more information about Saved Views.

Requires the "Export data from Lists" [permission](/pages/external-api-v2/permissions).



## OpenAPI

````yaml /schema/temp/publish.yml get /v2/lists/{listId}/saved-views/{viewId}/list-entries
openapi: 3.1.1
info:
  version: 0.0.1
  x-affinity-api-version: '2024-01-01'
  contact:
    email: support@affinity.co
    name: Affinity Support
    url: https://support.affinity.co
  description: >
    # Introduction


    Welcome to Affinity API v2! This API provides a RESTful interface for
    building internal apps,

    automated workflows, 3rd party integrations, and for connecting Affinity to
    the rest of your tech

    stack.


    The legacy Affinity v1 API can be found at
    [api-docs.affinity.co](https://api-docs.affinity.co/).

    The v2 API is not at feature parity with v1 - we are continuing to develop
    new v2 APIs to support

    all v1 functionality over time.


    **The Affinity APIs are only available on select license types.** See

    [this Help Center
    article](https://support.affinity.co/hc/en-us/articles/5563700459533-Getting-started-with-the-Affinity-API-FAQs)

    or contact your Customer Success Manager for more information.


    # Getting Started


    All Affinity API endpoints use the base URL `https://api.affinity.co`. All
    v2 endpoint paths start

    with `/v2`. Requests must be sent over HTTPS.


    The first few sections of these docs cover general information on the API.
    Each subsequent section

    covers a set of API endpoints.


    Each endpoint is documented with its accepted request parameters, expected
    response shapes, and a

    sample request and response. The shape of a given response can vary
    depending on what "type" of

    object or data is being returned. When this is the case, the response
    documentation will include a

    dropdown that can be used to select the "type" for which to display the
    response shape.


    ## Authentication


    Affinity API v2 uses API keys and **bearer authentication**.


    To generate an API key, navigate to the Manage Apps Page in your Affinity
    Settings. You will need

    the "Generate an API key" role-based permission controlled by your Affinity
    admin. See

    [this Help Center
    article](https://support.affinity.co/hc/en-us/articles/360032633992-How-to-obtain-your-API-Key)

    for full instructions on API key generation, and

    [this
    article](https://support.affinity.co/hc/en-us/articles/360015976732-Account-Level-Permissions)

    for more information on role-based permissions in Affinity.


    Provide your API key as your bearer authentication token to start making
    calls to Affinity API v2.


    You can create multiple API keys and provide a name and description for
    each. Your API key is able

    to read data and perform actions in Affinity on your behalf, so keep it safe
    as you would a

    password. To further secure an API key, you can define an IP Allowlist to
    limit which IP addresses

    or ranges can make API calls using that key.


    ## Permissions


    ### Overall Requirements


    You must have the "Generate an API key" permission to be able to work with
    the Affinity API. Most

    users in Affinity have this by default — Contact your Affinity admin if you
    are not able to generate

    an API key, and see

    [this
    article](https://support.affinity.co/hc/en-us/articles/360015976732-Account-Level-Permissions)

    for more information on role-based permissions in Affinity.


    ### Resource-Level Permissions


    The Affinity API respects sharing permissions that are set in-product. For
    example, if a given user

    does not have access to a list, note, or interaction in-product, they will
    not be able to see or

    modify it via API.


    ### Endpoint-Level Permissions


    Many API endpoints require endpoint-specific permissions in-product. These
    permissions, along with

    the "Generate an API key" permission, are managed by your Affinity admin in
    the Settings page. In

    the description of each endpoint you will see the required permissions
    needed.


    ## Rate Limits


    The Affinity API sets a limit on the number of calls that a user can make
    per minute, and that all

    the users on an account can make per month. It also sets a reasonable limit
    on the number of

    concurrent requests it will support from an account at one time.


    Requests to **both** Affinity API versions will count toward the one pool of
    requests allowed for a

    user or account. Once a per-minute, monthly, or concurrent rate limit is
    hit, subsequent requests

    will return an error code of 429. **We highly recommend designing your
    application to handle 429

    errors.**


    ### Per-Minute Limits (User-Level)


    To help protect our systems, API requests will be halted at **900 per user,
    per minute.** We may

    also lower this limit on a temporary basis to manage API availability.


    ### Concurrent Request Limits (Account-Level)


    To protect our systems and manage availability across customers, we set a
    reasonable limit on

    concurrent requests at the account level. Customers should not expect to hit
    this limit unless they

    are hitting the API with heavy operations from many concurrent threads at
    once.


    ### Monthly Plan Tier Limits (Account-Level)


    The overall number of requests you can make per month will depend on your
    account's plan tier.

    **This monthly account-level limit resets at the end of each calendar
    month.** Current rate limits

    by plan tier are:


    | Plan Tier  | Calls Per Month |

    | ---------- | --------------- |

    | Essentials | None            |

    | Scale      | 100k            |

    | Advanced   | 100k            |

    | Enterprise | Unlimited\*     |


    \*Per-Minute and Concurrent Request Limits still apply.


    ### Rate Limit Headers


    All API calls will return the following response headers with information
    about per-minute and

    monthly limits:


    | Header                           |
    Description                                             |

    | -------------------------------- |
    ------------------------------------------------------- |

    | x-ratelimit-limit-user           | Number of requests allowed per minute
    for the user      |

    | x-ratelimit-limit-user-remaining | Number of requests remaining for the
    user               |

    | x-ratelimit-limit-user-reset     | Time in seconds before the limit resets
    for the user    |

    | x-ratelimit-limit-org            | Number of requests allowed per month
    for the account    |

    | x-ratelimit-limit-org-remaining  | Number of requests remaining for the
    account            |

    | x-ratelimit-limit-org-reset      | Time in seconds before the limit resets
    for the account |


    ## Pagination


    When an endpoint is expected to return multiple results, we break the
    results into pages to make

    them easier to handle. To cycle forward through multiple pages of data, look
    for the `nextUrl`

    property in the `pagination` portion of an API response, and use it for your
    next request. See

    endpoint documentation for more information.


    ## Filtering


    Some endpoints support a filtering language for flexible and powerful
    queries. This allows for the

    creation of complex filter expressions using different operators and boolean
    logic in a single

    filter string. The description of each endpoint will contain information on
    which filter properties

    and operators are supported.


    ### Rules


    - Spaces are insignificant by default. For example, `field = hello` and
    `field=hello` are both
      valid.
    - If spaces are significant, they need to be inside double quotes, for
    example,
      `field = "hello world"`
    - Special characters need to be escaped with a backslash: `field="hello\"
    world"` <br> Full list of
      special characters: `\ * ~ ! & = > < $ ^ | " ' ( ) ] [ /`
    - Use `&` and `|` for boolean operations: `foo = 1 | baz = 2 & bar = 3`.
    Boolean Algebra Logic is
      assumed: `&` takes precedence over `|`. When evaluating the condition above, `baz = 2 & bar = 3`
      will be computed first, and then the result will be `or`'ed with `foo=1`
    - Parentheses can be used to specify the order of operations. In the example
    above, to make sure
      that `foo = 1 | baz = 2` is evaluated first, parentheses must be placed
      `(foo = 1 | baz = 2) & bar = 3`

    ### Grammar


    #### Simple Types


    | Definition               | Property
    Type                                        | Operator |
    Example                                                                                  
    |

    | ------------------------ |
    ---------------------------------------------------- | -------- |
    -----------------------------------------------------------------------------------------
    |

    | exact match              |
    all                                                  | =        | content =
    “hello world” <br>
    content=hello                                                |

    | starts with              |
    text                                                 | =^       | content =^
    he                                                                            
    |

    | ends with                |
    text                                                 | =$       | content =$
    llo                                                                           
    |

    | contains                 |
    text                                                 | =~       | content =~
    lo                                                                            
    |

    | greater than             | int32, int64, float, double, decimal, date,
    datetime | \>       | count >
    1                                                                                
    |

    | greater than or equal to | int32, int64, float, double, decimal, date,
    datetime | \>=      | content >=
    1                                                                             
    |

    | less than                | int32, int64, float, double, decimal, date,
    datetime | \<       | count <
    1                                                                                
    |

    | less than or equal to    | int32, int64, float, double, decimal, date,
    datetime | \<=      | content <=
    1                                                                             
    |

    | is NULL                  |
    all                                                  | != \*    | content !=
    \*                                                                            
    |

    | is not NULL              |
    all                                                  | =\*      | content =
    \*                                                                             
    |

    | is empty                 |
    text                                                 | =""      | content =
    ""                                                                             
    |

    | negation                 |
    all                                                  | !        | content !=
    ”hello world” <br> !(content = ”hello world”) <br> !(content =^ “hello
    world”) |


    #### Collections (all types)


    | Definition                | Operator |
    Example                              |

    | ------------------------- | -------- |
    ------------------------------------ |

    | exact match with ordering | =        | industries =
    [Healthcare,Fintech]    |

    | contains all              | =~       | industries =~
    [Healthcare,Fintech]   |

    | empty                     | =[]      | industries
    =[]                       |

    | negation                  | !        | !(industries =
    [Healthcare,Fintech]) |


    ## Error Codes


    Here is a list of the error codes the API will return if something goes
    wrong (see endpoint

    documentation for endpoint-specific errors):


    | Error Code |
    Meaning                                                                                                                                                                                                    
    |

    | ---------- |
    -----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    |

    | 400        | Bad Request — See endpoint documentation for more
    information.                                                                                                                                             
    |

    | 401        | Unauthorized — Your API key is
    invalid.                                                                                                                                                                    
    |

    | 403        | Forbidden — Insufficient rights to a
    resource.                                                                                                                                                             
    |

    | 404        | Not Found — Requested resource does not exist. See endpoint
    documentation for more
    information.                                                                                                            
    |

    | 405        | Method Not Allowed — The method being used is not supported
    for this
    resource.                                                                                                                             
    |

    | 422        | Unprocessable Entity — Malformed parameters supplied. This
    can also happen in cases the parameters supplied logically cannot complete
    the request. In this case, an appropriate error message is delivered. |

    | 429        | Too Many Requests — You have exceeded the rate
    limit.                                                                                                                                                      
    |

    | 500        | Internal Server Error — We had a problem with our server. Try
    again
    later.                                                                                                                                 
    |

    | 503        | Service Unavailable — This shouldn't generally happen.
    Contact us if you encounter this
    error.                                                                                                             
    |


    ## Versioning


    Versioning in Affinity’s API ensures that your integrations remain stable as
    updates are introduced.

    Within API v2, minor versions identify releases that may include breaking or
    behavior-changing

    modifications, and they allow you to target the exact API behavior your
    integration depends on.


    When you create an API key in the Settings page, you'll select a **Default
    API Version** for that

    key. The current available versions are:


    - **2024-01-01** - The current stable version of the v2 API


    As new minor versions of Affinity API v2 are introduced, they will appear in
    this list. You’ll be

    able to create new keys using those versions or update an existing key to
    use a newer version.


    ## Beta Endpoints


    You’ll notice in our documentation that some endpoints will be marked as
    BETA. These endpoints are

    newly released and will eventually progress to General Availability (GA).
    While an endpoint is in

    BETA there are some important things to consider:


    - The development of this endpoint may still be in progress. This means new
    capabilities, request
      parameters, response data, and performance improvements may be adjusted over time. Because of
      this, breaking changes may occur to the endpoint WITHOUT notice or versioning.
    - As this is an early release, bug fixes may still be ongoing as well, and
    we encourage you to
      report bugs to [support@affinity.co](mailto:support@affinity.co).
    - In addition, your feedback around the capabilities of the endpoint are
    highly valuable, please
      reach out to your CSM to provide feedback to our product team.

    # Data Model


    ## The Basics


    The three top-level objects in Affinity are **Persons, Companies, and
    Opportunities**. (Note:

    Companies are called Organizations in the Affinity web app.) These have
    profiles in the Affinity web

    app and can be added to Lists.


    A **List** is a spreadsheet-like collection of rows tied to Persons,
    Companies, or Opportunities.


    - Each row on a List is a **List Entry**. A List Entry contains data and
    metadata about a given
      Person, Company, or Opportunity in the context of a List. This includes list-specific field data,
      and information about who added the row to the List and when.
    - A given entity can be added to a List more than once. These List Entries
    can have different
      List-specific field data and List Entry-level metadata.

    Each column on a List maps to a **Field**. Fields show up within Affinity
    profile pages, extensions,

    and integrations. There are two categories of fields:


    - **List-specific fields** are scoped to a single List. In the API, their
    data can only be accessed
      through the List Entry resource.
    - **Global fields** belong to entities directly. These can include default
    fields, fields created by
      you, enrichment fields, or relationship intelligence fields. They can be accessed through the
      Person/Company/Opportunity resources and the List Entry resource.

    ## Working with Field Data


    ### Field Types and IDs


    Here is a deeper look at the types of Fields in Affinity, differentiated by
    the scope and source of

    their data:


    | Field&nbsp;Type             |
    Description                                                                                                                                                 
    | Example
    Fields                                                                                                                                             
    | Field ID
    Pattern                                                                                                                            
    |

    | --------------------------- |
    ------------------------------------------------------------------------------------------------------------------------------------------------------------
    |
    -----------------------------------------------------------------------------------------------------------------------------------------------------------
    |
    --------------------------------------------------------------------------------------------------------------------------------------------
    |

    | `enriched`                  | Firmographic, funding, and people Fields
    populated by Affinity. These can be "Affinity Data" Fields or come from
    distinct data partners.                     | "Affinity Data: Description",
    "Dealroom: Number of
    Employees"                                                                                              
    | A string representing the enrichment source, followed by the field name,
    e.g. `affinity-data-description` or `dealroom-number-of-employees`. |

    | `list`                      | Fields that are specific to the context of a
    given list. These can only be accessed through `*/list-entries` endpoints in
    this version of the API.           | Default "Status" and "Amount" columns,
    custom columns that pertain to a given List of deals or
    founders                                                     | `field-`,
    followed by a unique integer, e.g.
    `field-1234`                                                                                   
    |

    | `global`                    | Fields that persist across an Affinity
    account and are not
    list-specific.                                                                                   
    | "My Firm's Founder Scoring
    Column"                                                                                                                         
    | `field-`, followed by a unique integer, e.g.
    `field-1234`                                                                                   
    |

    | `relationship-intelligence` | Fields populated by Affinity from users'
    email and calendar data that provide insight into your firm's relationship
    with a given Person/Company/Opportunity. | "Source of Introduction", "First
    Email", "Last Email", "First Event", "Last Event", "Next Event", "First Chat
    Message", "Last Chat Message", "Last Contact" | A string similar to the
    field's name in-product, e.g.
    `source-of-introduction`                                                              
    |


    ### Field Value Types


    Field data can take a variety of shapes. These value types are described in
    the Affinity Help Center

    [creating columns in
    lists](https://support.affinity.co/hc/en-us/articles/115001608232-How-to-create-a-new-column-in-a-list).

    Here is a list of the same value types, as represented in this API. Notice
    how array types end with

    `-multi`:


    | Single Type         | Array Type                |

    | ------------------- | ------------------------- |

    | `text`              | Not supported in Affinity |

    | `number`            | `number-multi`            |

    | `datetime`          | Not supported in Affinity |

    | `location`          | `location-multi`          |

    | `dropdown`          | `dropdown-multi`          |

    | `ranked-dropdown`   | Not supported in Affinity |

    | `person`            | `person-multi`            |

    | `company`           | `company-multi`           |

    | `filterable-text`\* | `filterable-text-multi`\* |


    \*Note that `filterable-text` and `filterable-text-multi` are special types
    that operate similarly

    to `dropdown` and `dropdown-multi`. They are reserved for Affinity-populated
    Fields, and users

    cannot create Fields with these types.


    When an array-typed value has no data in it, the API will return `null`
    (rather than an empty

    array).


    ### Retrieving Field Data


    To retrieve field data on companies, persons, or opportunities, call GET
    `/v2/companies`, GET

    `/v2/persons`, or one of our GET `*/list-entries` endpoints. (Note that
    Opportunities only have

    list-specific Fields, so all their field data will live on the
    `*/list-entries` endpoints.) For most

    of these endpoints, you will need to specify the Fields for which you want
    data returned via the

    `fieldIds` or `fieldTypes` parameter — Otherwise, entities will be returned
    without any field data

    attached.


    The GET `/v2/companies` and `/v2/persons` endpoints can return entities with
    enriched, global, and

    relationship intelligence field data attached, but do not support
    list-specific field data. **To get

    comprehensive field data including list-specific field data on Companies and
    Persons, use the GET

    `*/list-entries` endpoints.**


    ### Specifying Desired Fields (Field Selection)


    As mentioned above, you will need to specify the Fields (either by ID or by
    Type) for which you want

    data returned when using the following endpoints:


    - GET `/v2/companies`

    - GET `/v2/companies/{id}`

    - GET `/v2/persons`

    - GET `/v2/persons/{id}`

    - GET `/v2/lists/{listId}/list-entries`


    Each of these endpoints has a `fieldIds` parameter that accepts an array of
    Field IDs, and a

    `fieldTypes` parameter that accepts an array of Field Types. Use the GET
    `*/fields` endpoints to get

    Field IDs, Field Types, and other Field-level metadata:


    - Call GET `/v2/companies/fields` and `/v2/persons/fields` to get a list of
    the enriched, global,
      and relationship intelligence (AKA non-list-specific) Fields that exist on Companies and Persons,
      respectively. These are the Fields whose values are available to pull via GET `/v2/companies`, GET
      `/v2/companies/{id}`, GET `/v2/persons`, and `/v2/persons/{id}`.
    - Call GET `/v2/lists/{listId}/fields` to get a list of the enriched,
    global, relationship
      intelligence, **and list-specific** Fields for a given List. These are the Fields whose values are
      available to pull via GET `/v2/lists/{listId}/list-entries`.

    The following endpoints don't require field selection:


    - GET `/v2/lists/{listId}/saved-views/{viewId}/list-entries` — See below.
    This endpoint returns just
      the field data that has been pulled into the given Saved View via UI.
    - GET `/v2/companies/{id}/list-entries` and GET
    `/v2/persons/{id}/list-entries` — These endpoints
      return comprehensive field data for the given person or company in the context of each List Entry.

    ### Saved Views


    A Saved View allows a user to configure the Fields they want to see in the
    UI for a given List, and

    set filters and sorts on the rows on that List. A List can have multiple
    Saved Views. In the context

    of this API, Saved Views can be useful for specifying the exact Fields for
    which data is needed. The

    `*/saved-views/{viewId}/list-entries` endpoint also respects the filters
    that have been set on the

    given Saved View in the Affinity web app. (It does not, however, respect
    sorts just yet.)


    ### Partner Data Restrictions


    This API supports pulling data from

    [Affinity
    Data](https://support.affinity.co/hc/en-us/articles/360058255052-Affinity-Data)
    fields and

    select

    [Dealroom
    fields](https://support.affinity.co/hc/en-us/articles/6106558518797-Dealroom-co-data-in-Affinity#h_01G2N22SVH7TJR3DJV3NQDE9HQ).

    Due the agreements we have with some of our data partners, the API does not
    expose data from the

    following sources:


    - Crunchbase, including Crunchbase UUID

    - Pitchbook

    - [Dealroom "exclusive"
    fields](https://support.affinity.co/hc/en-us/articles/6106558518797-Dealroom-co-data-in-Affinity#h_01G2N22YEAZJ5TC1X9ENKZFWF5)


    ## Nested Associations


    Some GET endpoints return "association" data under `fields`. For example,
    the Persons GET endpoints

    return data about which Companies a Person is associated with in Affinity.
    The Opportunities GET

    endpoints return similar data about associated Companies and Persons. The
    List Entries GET endpoints

    also return this data for Person and Opportunity List Entries.


    The API truncates these nested arrays of Persons or Companies **at 100
    entries**. For example, if an

    Opportunity is associated with 200 Persons in Affinity, only 100 of those
    Persons will be returned

    by the GET `/opportunities` or `/opportunities/{id}` endpoint.


    # Changelog


    ## January 30th, 2026


    - The following endpoints are no longer in BETA:


    | Method | URL                                         |
    Summary                                        |

    | ------ | ------------------------------------------- |
    ---------------------------------------------- |

    | GET    | `/v2/notes`                                 | Get all
    Notes                                  |

    | GET    | `/v2/notes/{noteId}`                        | Get a Note with a
    given id                     |

    | GET    | `/v2/notes/{noteId}/attached-companies`     | Get directly
    attached companies for a Note     |

    | GET    | `/v2/notes/{noteId}/attached-opportunities` | Get directly
    attached opportunities for a Note |

    | GET    | `/v2/notes/{noteId}/attached-persons`       | Get directly
    attached persons for a Note       |

    | GET    | `/v2/notes/{noteId}/replies`                | Get reply notes for
    a given Note               |


    ## January 26th, 2026


    - Added the following endpoints in BETA:


    | Method | URL                                        |
    Summary                              |

    | ------ | ------------------------------------------ |
    ------------------------------------ |

    | GET    | `/v2/transcripts`                          | Get All
    Transcripts                  |

    | GET    | `/v2/transcripts/{transcriptId}`           | Get
    Transcript                       |

    | GET    | `/v2/transcripts/{transcriptId}/fragments` | Get Fragments on a
    single Transcript |


    ## January 14th, 2026


    - Rate limit response headers have been updated to use lowercase formatting.
    This change affects all
      API endpoints. The new lowercase headers are:

    | Header                           |
    Description                                             |

    | -------------------------------- |
    ------------------------------------------------------- |

    | x-ratelimit-limit-user           | Number of requests allowed per minute
    for the user      |

    | x-ratelimit-limit-user-remaining | Number of requests remaining for the
    user               |

    | x-ratelimit-limit-user-reset     | Time in seconds before the limit resets
    for the user    |

    | x-ratelimit-limit-org            | Number of requests allowed per month
    for the account    |

    | x-ratelimit-limit-org-remaining  | Number of requests remaining for the
    account            |

    | x-ratelimit-limit-org-reset      | Time in seconds before the limit resets
    for the account |


    ## January 1st, 2026


    - API Change: Handling timestamps for date fields. Affinity is standardizing
    how dates are
      represented across the platform to ensure consistency between the application and the API.
      Starting January 1st, 2026, the API will change how it handles timestamps for date fields. Today,
      timestamps sent to date fields over the API are not visible to users in any CRM interface. After
      this change, the API will ignore any time information included in requests, storing and returning
      values at midnight Pacific Time (PT) on the submitted date.

      **Example:**
      - API request includes: `2024-04-01T15:30:00Z`
      - Affinity will store and return: `2024-04-01T07:00:00.000Z` (equivalent to midnight PT)

      Any existing date field values that currently include timestamps will also be updated to reflect
      midnight PT on their stored date. No action is required unless your integration depends on time
      data within date fields.

    ## September 25th, 2025


    - Added the following endpoints in BETA:


    | Method | URL                                 |
    Summary                      |

    | ------ | ----------------------------------- |
    ---------------------------- |

    | GET    | `/v2/company-merges`                | Get All Company Merge
    status |

    | POST   | `/v2/company-merges`                | Initiate Company
    Merge       |

    | GET    | `/v2/company-merges/{mergeId}`      | Get Company Merge
    status     |

    | GET    | `/v2/tasks/company-merges`          | Get All Company Merge
    Tasks  |

    | GET    | `/v2/tasks/company-merges/{taskId}` | Get Company Merge
    Task       |


    ## July 30th, 2025


    - Added the following endpoints in BETA:


    | Method | URL                                         |
    Summary                                        |

    | ------ | ------------------------------------------- |
    ---------------------------------------------- |

    | GET    | `/v2/person-merges`                         | Get All Person
    Merge status                    |

    | POST   | `/v2/person-merges`                         | Initiate Person
    Merge                          |

    | GET    | `/v2/person-merges/{mergeId}`               | Get Person Merge
    status                        |

    | GET    | `/v2/tasks/person-merges`                   | Get All Person
    Merge Tasks                     |

    | GET    | `/v2/tasks/person-merges/{taskId}`          | Get Person Merge
    Task                          |

    | GET    | `/v2/notes`                                 | Get all
    Notes                                  |

    | GET    | `/v2/notes/{noteId}`                        | Get a Note with a
    given id                     |

    | GET    | `/v2/notes/{noteId}/attached-companies`     | Get directly
    attached companies for a Note     |

    | GET    | `/v2/notes/{noteId}/attached-opportunities` | Get directly
    attached opportunities for a Note |

    | GET    | `/v2/notes/{noteId}/attached-persons`       | Get directly
    attached persons for a Note       |

    | GET    | `/v2/notes/{noteId}/replies`                | Get reply notes for
    a given Note               |


    ## May 14th, 2025


    - Renamed all path parameters named simply "id" to a more descriptive name
    (eg. "personId"). This
      will not have any effect on the API at runtime, but may impact code relying on the OpenAPI spec
      doing type generation.

    ## April 9th, 2025


    - The following endpoints are no longer in BETA:


    | Method | URL                                                             
    | Summary                                           |

    | ------ | ----------------------------------------------------------------
    | ------------------------------------------------- |

    | GET    | `/v2/lists/{listId}/list-entries/{listEntryId}`                 
    | Get a single List Entry on a List                 |

    | GET    | `/v2/lists/{listId}/list-entries/{listEntryId}/fields`          
    | Get field values on a single List Entry           |

    | PATCH  | `/v2/lists/{listId}/list-entries/{listEntryId}/fields`          
    | Perform batch operations on a list entry's fields |

    | GET    | `/v2/lists/{listId}/list-entries/{listEntryId}/fields/{fieldId}`
    | Get a single field value                          |

    | POST   | `/v2/lists/{listId}/list-entries/{listEntryId}/fields/{fieldId}`
    | Update a single field value on a List Entry       |


    ## March 31st, 2025


    - The following beta endpoints now support updating association fields.


    | Method | URL                                                             
    | Summary                                           |

    | ------ | ----------------------------------------------------------------
    | ------------------------------------------------- |

    | PATCH  | `/v2/lists/{listId}/list-entries/{listEntryId}/fields`          
    | Perform batch operations on a list entry's fields |

    | POST   | `/v2/lists/{listId}/list-entries/{listEntryId}/fields/{fieldId}`
    | Update a single field value on a List Entry       |


    ## February 28th, 2025


    - Added the following endpoints in BETA:


    | Method | URL                                                             
    | Summary                                           |

    | ------ | ----------------------------------------------------------------
    | ------------------------------------------------- |

    | GET    | `/v2/lists/{listId}/list-entries/{listEntryId}`                 
    | Get a single List Entry on a List                 |

    | GET    | `/v2/lists/{listId}/list-entries/{listEntryId}/fields`          
    | Get field values on a single List Entry           |

    | PATCH  | `/v2/lists/{listId}/list-entries/{listEntryId}/fields`          
    | Perform batch operations on a list entry's fields |

    | GET    | `/v2/lists/{listId}/list-entries/{listEntryId}/fields/{fieldId}`
    | Get a single field value                          |

    | POST   | `/v2/lists/{listId}/list-entries/{listEntryId}/fields/{fieldId}`
    | Update a single field value on a List Entry       |


    ## January 17th, 2025


    - Document `X-Ratelimit` headers in the schema for all endpoints.


    ## January 15th, 2025


    - Add default responses to all endpoints to document all possible error
    codes that can be returned
      by the API.
    - Updated 400 error responses to correctly include the `bad-request` error
    code as a possible error.


    ## December 3rd, 2024


    - Properly document `listId` property on `CompanyListEntry`,
    `PersonListEntry`, and
      `OpportunityListEntry` schemas.

    ## September 25th, 2024


    - Upgrade schema to OpenAPI 3.1


    ## August 5, 2024


    - Correct `opp` to `opportunity` to match documentation for the `List`
    `type` property.


    ## July 24, 2024


    - More accurate documentation for response properties that are enums — Enums
    with `null` as a
      possible value will have it listed as one.

    ## March 25, 2024


    - Added the ability to retrieve the date and other details of your firm's
    "First Email", "Last
      Email", "First Event", "Last Event", "Next Event", "First Chat Message", "Last Chat Message", and
      "Last Contact" with a given entity. Use these timestamps to add relationship context to your
      applications, and to identify founders and companies that need investors' attention.
    - Endpoints that previously required a `fieldIds` parameter to return field
    data, now accept either
      `fieldIds` or `fieldTypes`, and will return field data accordingly. See the
      [Specifying Desired Fields (Field Selection)](/pages/data-model/working-with-field-data) section
      of these docs for more information. The new `fieldTypes` parameter should make field data
      retrieval easier for users looking to pull data from many similar Fields at a time.

    ## January 4, 2023


    - Most endpoints that return field data now require the user to use the
    `fieldIds` parameter to
      specify which Fields they want data for. Without `fieldIds` specified, these endpoints will return
      basic entity data but not field data.

    ## December 12, 2023


    - Added the ability to retrieve metadata (e.g. ID, name, type, enrichment
    source, and data type) on
      Fields. See the [Retrieving Field Metadata](/pages/data-model/working-with-field-data) section of
      these docs for more information.
  license:
    name: Proprietary
    url: https://www.affinity.co/legal/terms-of-use
  termsOfService: https://www.affinity.co/legal/terms-of-use
  title: Affinity API v2
  x-logo:
    url: https://assets.affinity.co/img/logos/full-color-svg.svg
    altText: Affinity logo
servers:
  - url: https://api.affinity.co
security:
  - bearerAuth: []
tags:
  - description: Operations about Auth
    name: Auth
  - description: Operations about Calls
    name: Calls
  - description: Operations about chat messages
    name: Chat Messages
  - description: Operations about companies
    name: Companies
  - description: Operations about company merges
    name: Company Merges
  - description: Operations about emails
    name: Emails
  - description: Operations about feedback
    name: Feedback
  - description: Operations about field value changes
    name: Field Value Changes
  - description: Operations about files
    name: Files
  - description: Operations about lists
    name: Lists
  - description: Operations about meetings
    name: Meetings
  - description: Operations about notes
    name: Notes
  - description: Operations about opportunities
    name: Opportunities
  - description: Operations about person merges
    name: Person Merges
  - description: Operations about persons
    name: Persons
  - description: Operations about reminders
    name: Reminders
  - description: Operations about semantic searches
    name: Semantic Search
  - description: Operations about transcripts
    name: Transcripts
  - description: Operations about users
    name: Users
paths:
  /v2/lists/{listId}/saved-views/{viewId}/list-entries:
    get:
      tags:
        - Lists
      summary: Get all List Entries on a Saved View
      description: >-
        Paginate through the List Entries (AKA rows) on a given Saved View.

        Use this endpoint when you need to filter entities or only want **some**

        field data to be returned: This endpoint respects the filters set on a
        Saved View

        via web app, and only returns field data corresponding to the columns
        that have been

        pulled into the Saved View via web app.


        Though this endpoint respects the Saved View's filters and column/Field
        selection,

        it does not yet preserve sort order. This endpoint also only supports
        **sheet-type

        Saved Views**, and not board- or dashboard-type Saved Views.


        See the [Data Model](/pages/data-model/the-basics) section for more
        information about Saved Views.


        Requires the "Export data from Lists"
        [permission](/pages/external-api-v2/permissions).
      operationId: v2_lists_listId_saved-views_viewId_list-entries__GET
      parameters:
        - name: listId
          description: List ID
          in: path
          required: true
          schema:
            type: integer
            format: int64
            minimum: 1
            maximum: 9007199254740991
        - name: viewId
          description: Saved view ID
          in: path
          required: true
          schema:
            type: integer
            format: int64
            minimum: 1
            maximum: 9007199254740991
        - name: cursor
          description: Cursor for the next or previous page
          in: query
          schema:
            type: string
            examples:
              - ICAgICAgYmVmb3JlOjo6Nw
          example: ICAgICAgYmVmb3JlOjo6Nw
        - name: limit
          description: Number of items to include in the page
          in: query
          schema:
            type: integer
            format: int32
            minimum: 1
            maximum: 100
            default: 100
            examples:
              - 100
          example: 100
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ListEntryWithEntityPaged'
          headers:
            x-ratelimit-limit-user:
              $ref: '#/components/headers/X-Ratelimit-Limit-User'
            x-ratelimit-limit-user-remaining:
              $ref: '#/components/headers/X-Ratelimit-Limit-User-Remaining'
            x-ratelimit-limit-user-reset:
              $ref: '#/components/headers/X-Ratelimit-Limit-User-Reset'
            x-ratelimit-limit-org:
              $ref: '#/components/headers/X-Ratelimit-Limit-Org'
            x-ratelimit-limit-org-remaining:
              $ref: '#/components/headers/X-Ratelimit-Limit-Org-Remaining'
            x-ratelimit-limit-org-reset:
              $ref: '#/components/headers/X-Ratelimit-Limit-Org-Reset'
        '400':
          $ref: '#/components/responses/400'
        '403':
          $ref: '#/components/responses/403'
        '404':
          $ref: '#/components/responses/404'
        default:
          $ref: '#/components/responses/default'
components:
  schemas:
    ListEntryWithEntityPaged:
      title: ListEntryWithEntityPaged
      description: ListEntryWithEntityPaged model
      type: object
      properties:
        data:
          description: A page of ListEntryWithEntity results
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/ListEntryWithEntity'
          maxItems: 100
        pagination:
          $ref: '#/components/schemas/Pagination'
      required:
        - data
        - pagination
      additionalProperties: false
    ListEntryWithEntity:
      title: ListEntryWithEntity
      oneOf:
        - $ref: '#/components/schemas/CompanyListEntry'
        - $ref: '#/components/schemas/OpportunityListEntry'
        - $ref: '#/components/schemas/PersonListEntry'
      discriminator:
        propertyName: type
        mapping:
          company:
            $ref: '#/components/schemas/CompanyListEntry'
          opportunity:
            $ref: '#/components/schemas/OpportunityListEntry'
          person:
            $ref: '#/components/schemas/PersonListEntry'
    Pagination:
      title: Pagination
      type: object
      properties:
        prevUrl:
          description: URL for the previous page
          type:
            - string
            - 'null'
          format: uri
          example: https://api.affinity.co/v2/foo?cursor=ICAgICAgYmVmb3JlOjo6Nw
        nextUrl:
          description: URL for the next page
          type:
            - string
            - 'null'
          format: uri
          example: https://api.affinity.co/v2/foo?cursor=ICAgICAgIGFmdGVyOjo6NA
    BadRequestError:
      title: BadRequestError
      type: object
      properties:
        code:
          description: Error code
          type: string
          const: bad-request
          example: bad-request
        message:
          description: Error message
          type: string
      required:
        - code
        - message
      additionalProperties: false
    ValidationError:
      title: ValidationError
      type: object
      properties:
        code:
          description: Error code
          type: string
          const: validation
          example: validation
        message:
          description: Error message
          type: string
        param:
          description: Param the error refers to
          type: string
          example: limit
      required:
        - code
        - message
        - param
      additionalProperties: false
    AuthorizationErrors:
      title: AuthorizationErrors
      description: AuthorizationErrors model
      type: object
      properties:
        errors:
          description: AuthorizationError errors
          type: array
          items:
            $ref: '#/components/schemas/AuthorizationError'
      required:
        - errors
      additionalProperties: false
    NotFoundErrors:
      title: NotFoundErrors
      description: NotFoundErrors model
      type: object
      properties:
        errors:
          description: NotFoundError errors
          type: array
          items:
            $ref: '#/components/schemas/NotFoundError'
      required:
        - errors
      additionalProperties: false
    Errors:
      title: Errors
      type: object
      properties:
        errors:
          description: Errors
          type: array
          items:
            $ref: '#/components/schemas/Error'
      required:
        - errors
      additionalProperties: false
    CompanyListEntry:
      title: CompanyListEntry
      type: object
      properties:
        id:
          description: The list entry's unique identifier
          type: integer
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        type:
          description: The entity type for this list entry
          type: string
          const: company
          example: company
        listId:
          description: The ID of the list that this list entry belongs to
          type: integer
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        createdAt:
          description: The date that the list entry was created
          type: string
          format: date-time
          example: '2023-01-01T00:00:00Z'
        creatorId:
          description: The ID of the user that created this list entry
          type:
            - integer
            - 'null'
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        entity:
          $ref: '#/components/schemas/Company'
      required:
        - createdAt
        - creatorId
        - entity
        - id
        - listId
        - type
      additionalProperties: false
      example:
        id: 1
        type: company
        listId: 1
        createdAt: '2023-01-01T00:00:00Z'
        creatorId: 1
        entity:
          id: 1
          name: Horizon Technologies
          domain: horizontech.com
          domains:
            - horizontech.com
          isGlobal: true
          fields: []
    OpportunityListEntry:
      title: OpportunityListEntry
      type: object
      properties:
        id:
          description: The list entry's unique identifier
          type: integer
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        type:
          description: The entity type for this list entry
          type: string
          const: opportunity
          example: opportunity
        listId:
          description: The ID of the list that this list entry belongs to
          type: integer
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        createdAt:
          description: The date that the list entry was created
          type: string
          format: date-time
          example: '2023-01-01T00:00:00Z'
        creatorId:
          description: The ID of the user that created this list entry
          type:
            - integer
            - 'null'
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        entity:
          $ref: '#/components/schemas/OpportunityWithFields'
      required:
        - createdAt
        - creatorId
        - entity
        - id
        - listId
        - type
      additionalProperties: false
      example:
        id: 1
        type: opportunity
        listId: 1
        createdAt: '2023-01-01T00:00:00Z'
        creatorId: 1
        entity:
          id: 1
          name: Horizon Technologies Series A
          listId: 1
          fields: []
          isRestricted: false
          isRedacted: false
    PersonListEntry:
      title: PersonListEntry
      type: object
      properties:
        id:
          description: The list entry's unique identifier
          type: integer
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        type:
          description: The entity type for this list entry
          type: string
          const: person
          example: person
        listId:
          description: The ID of the list that this list entry belongs to
          type: integer
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        createdAt:
          description: The date that the list entry was created
          type: string
          format: date-time
          example: '2023-01-01T00:00:00Z'
        creatorId:
          description: The ID of the user that created this list entry
          type:
            - integer
            - 'null'
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        entity:
          $ref: '#/components/schemas/Person'
      required:
        - createdAt
        - creatorId
        - entity
        - id
        - listId
        - type
      additionalProperties: false
      example:
        id: 1
        type: person
        listId: 1
        createdAt: '2023-01-01T00:00:00Z'
        creatorId: 1
        entity:
          id: 1
          firstName: Alex
          lastName: Rivera
          primaryEmailAddress: alex.rivera@horizontech.com
          emailAddresses:
            - alex.rivera@horizontech.com
          type: internal
          fields: []
    AuthorizationError:
      title: AuthorizationError
      type: object
      properties:
        code:
          description: Error code
          type: string
          const: authorization
          example: authorization
        message:
          description: Error message
          type: string
      required:
        - code
        - message
      additionalProperties: false
    NotFoundError:
      title: NotFoundError
      type: object
      properties:
        code:
          description: Error code
          type: string
          const: not-found
          example: not-found
        message:
          description: Error message
          type: string
      required:
        - code
        - message
      additionalProperties: false
    Error:
      title: Error
      oneOf:
        - $ref: '#/components/schemas/AuthenticationError'
        - $ref: '#/components/schemas/AuthorizationError'
        - $ref: '#/components/schemas/BadRequestError'
        - $ref: '#/components/schemas/ConflictError'
        - $ref: '#/components/schemas/MethodNotAllowedError'
        - $ref: '#/components/schemas/NotAcceptableError'
        - $ref: '#/components/schemas/NotFoundError'
        - $ref: '#/components/schemas/NotImplementedError'
        - $ref: '#/components/schemas/RateLimitError'
        - $ref: '#/components/schemas/ServerError'
        - $ref: '#/components/schemas/TimeoutError'
        - $ref: '#/components/schemas/UnprocessableEntityError'
        - $ref: '#/components/schemas/UnsupportedMediaTypeError'
        - $ref: '#/components/schemas/ValidationError'
      discriminator:
        propertyName: code
        mapping:
          authentication:
            $ref: '#/components/schemas/AuthenticationError'
          authorization:
            $ref: '#/components/schemas/AuthorizationError'
          bad-request:
            $ref: '#/components/schemas/BadRequestError'
          conflict:
            $ref: '#/components/schemas/ConflictError'
          method-not-allowed:
            $ref: '#/components/schemas/MethodNotAllowedError'
          not-acceptable:
            $ref: '#/components/schemas/NotAcceptableError'
          not-found:
            $ref: '#/components/schemas/NotFoundError'
          not-implemented:
            $ref: '#/components/schemas/NotImplementedError'
          rate-limit:
            $ref: '#/components/schemas/RateLimitError'
          server:
            $ref: '#/components/schemas/ServerError'
          timeout:
            $ref: '#/components/schemas/TimeoutError'
          unprocessable-entity:
            $ref: '#/components/schemas/UnprocessableEntityError'
          unsupported-media-type:
            $ref: '#/components/schemas/UnsupportedMediaTypeError'
          validation:
            $ref: '#/components/schemas/ValidationError'
    Company:
      title: Company
      description: Company model
      type: object
      properties:
        id:
          description: The company's unique identifier
          type: integer
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        name:
          description: The company's name
          type: string
          example: Horizon Technologies
        domain:
          description: The company's primary domain
          type:
            - string
            - 'null'
          format: hostname
          example: horizontech.com
        domains:
          description: All of the company's domains
          type: array
          items:
            type: string
            format: hostname
          example:
            - horizontech.com
        isGlobal:
          description: Whether or not the company is tenant specific
          type: boolean
          example: true
        fields:
          description: The fields associated with the company
          type: array
          items:
            $ref: '#/components/schemas/Field'
      required:
        - domain
        - domains
        - id
        - isGlobal
        - name
      additionalProperties: false
    OpportunityWithFields:
      title: OpportunityWithFields
      description: Opportunity model including the opportunity's fields.
      type: object
      properties:
        id:
          description: The unique identifier for the opportunity
          type: integer
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        name:
          description: The name of the opportunity.
          type: string
          example: Horizon Technologies Upsell $10k
        listId:
          description: The ID of the list that the opportunity belongs to
          type: integer
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        fields:
          description: |
            The fields associated with the opportunity. Empty for a redacted
            opportunity.
          type: array
          items:
            $ref: '#/components/schemas/Field'
        isRestricted:
          description: |
            Whether the opportunity is restricted. `false` for customers without
            the Restricted Opportunities feature enabled.
          type: boolean
          example: false
        isRedacted:
          description: >
            Whether the response is redacted because the requesting user does
            not

            have access to sensitive details of this restricted opportunity.
            When

            `true`, `fields` is empty. Always `false` when `isRestricted` is

            `false`.
          type: boolean
          example: false
      required:
        - id
        - listId
        - name
        - isRestricted
        - isRedacted
      additionalProperties: false
    Person:
      title: Person
      description: Person model
      type: object
      properties:
        id:
          description: The persons's unique identifier
          type: integer
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        firstName:
          description: The person's first name
          type: string
          example: Jane
        lastName:
          description: The person's last name
          type:
            - string
            - 'null'
          example: Doe
        primaryEmailAddress:
          description: The person's primary email address
          type:
            - string
            - 'null'
          format: email
          example: jane.smith@northpointvc.com
        emailAddresses:
          description: All of the person's email addresses
          type: array
          items:
            type: string
            format: email
          example:
            - jane.smith@northpointvc.com
            - janedoe@gmail.com
        type:
          description: >-
            The person's type. `internal` - people who are users within your
            Affinity instance. `external` - people who are not internal.
          type: string
          enum:
            - internal
            - external
          example: internal
        fields:
          description: The fields associated with the person
          type: array
          items:
            $ref: '#/components/schemas/Field'
      required:
        - emailAddresses
        - firstName
        - id
        - lastName
        - primaryEmailAddress
        - type
      additionalProperties: false
    AuthenticationError:
      title: AuthenticationError
      type: object
      properties:
        code:
          description: Error code
          type: string
          const: authentication
          example: authentication
        message:
          description: Error message
          type: string
      required:
        - code
        - message
      additionalProperties: false
    ConflictError:
      title: ConflictError
      type: object
      properties:
        code:
          description: Error code
          type: string
          const: conflict
          example: conflict
        message:
          description: Error message
          type: string
      required:
        - code
        - message
      additionalProperties: false
    MethodNotAllowedError:
      title: MethodNotAllowedError
      type: object
      properties:
        code:
          description: Error code
          type: string
          const: method-not-allowed
          example: method-not-allowed
        message:
          description: Error message
          type: string
      required:
        - code
        - message
      additionalProperties: false
    NotAcceptableError:
      title: NotAcceptableError
      type: object
      properties:
        code:
          description: Error code
          type: string
          const: not-acceptable
          example: not-acceptable
        message:
          description: Error message
          type: string
      required:
        - code
        - message
      additionalProperties: false
    NotImplementedError:
      title: NotImplementedError
      type: object
      properties:
        code:
          description: Error code
          type: string
          const: not-implemented
          example: not-implemented
        message:
          description: Error message
          type: string
      required:
        - code
        - message
      additionalProperties: false
    RateLimitError:
      title: RateLimitError
      type: object
      properties:
        code:
          description: Error code
          type: string
          const: rate-limit
          example: rate-limit
        message:
          description: Error message
          type: string
      required:
        - code
        - message
      additionalProperties: false
    ServerError:
      title: ServerError
      type: object
      properties:
        code:
          description: Error code
          type: string
          const: server
          example: server
        message:
          description: Error message
          type: string
      required:
        - code
        - message
      additionalProperties: false
    TimeoutError:
      title: TimeoutError
      type: object
      properties:
        code:
          description: Error code
          type: string
          const: timeout
          example: timeout
        message:
          description: Error message
          type: string
      required:
        - code
        - message
      additionalProperties: false
    UnprocessableEntityError:
      title: UnprocessableEntityError
      type: object
      properties:
        code:
          description: Error code
          type: string
          const: unprocessable-entity
          example: unprocessable-entity
        message:
          description: Error message
          type: string
      required:
        - code
        - message
      additionalProperties: false
    UnsupportedMediaTypeError:
      title: UnsupportedMediaTypeError
      type: object
      properties:
        code:
          description: Error code
          type: string
          const: unsupported-media-type
          example: unsupported-media-type
        message:
          description: Error message
          type: string
      required:
        - code
        - message
      additionalProperties: false
    Field:
      title: Field
      type: object
      properties:
        id:
          description: The field's unique identifier
          type: string
          example: affinity-data-location
        name:
          description: The field's name
          type: string
          example: Location
        type:
          description: The field's type
          type: string
          enum:
            - enriched
            - global
            - list
            - relationship-intelligence
          example: enriched
        enrichmentSource:
          description: The source of the data in this Field (if it is enriched)
          type:
            - string
            - 'null'
          enum:
            - affinity-data
            - dealroom
            - eventbrite
            - mailchimp
            - null
          example: affinity-data
        value:
          $ref: '#/components/schemas/FieldValue'
      required:
        - enrichmentSource
        - id
        - name
        - type
        - value
      additionalProperties: false
    FieldValue:
      title: FieldValue
      oneOf:
        - $ref: '#/components/schemas/CompaniesValue'
        - $ref: '#/components/schemas/CompanyValue'
        - $ref: '#/components/schemas/DateValue'
        - $ref: '#/components/schemas/DropdownsValue'
        - $ref: '#/components/schemas/DropdownValue'
        - $ref: '#/components/schemas/FloatsValue'
        - $ref: '#/components/schemas/FloatValue'
        - $ref: '#/components/schemas/FormulaValue'
        - $ref: '#/components/schemas/InteractionValue'
        - $ref: '#/components/schemas/LocationsValue'
        - $ref: '#/components/schemas/LocationValue'
        - $ref: '#/components/schemas/PersonsValue'
        - $ref: '#/components/schemas/PersonValue'
        - $ref: '#/components/schemas/RankedDropdownValue'
        - $ref: '#/components/schemas/TextsValue'
        - $ref: '#/components/schemas/TextValue'
      discriminator:
        propertyName: type
        mapping:
          company:
            $ref: '#/components/schemas/CompanyValue'
          company-multi:
            $ref: '#/components/schemas/CompaniesValue'
          datetime:
            $ref: '#/components/schemas/DateValue'
          dropdown:
            $ref: '#/components/schemas/DropdownValue'
          dropdown-multi:
            $ref: '#/components/schemas/DropdownsValue'
          number:
            $ref: '#/components/schemas/FloatValue'
          number-multi:
            $ref: '#/components/schemas/FloatsValue'
          filterable-text:
            $ref: '#/components/schemas/TextValue'
          filterable-text-multi:
            $ref: '#/components/schemas/TextsValue'
          formula-number:
            $ref: '#/components/schemas/FormulaValue'
          interaction:
            $ref: '#/components/schemas/InteractionValue'
          location:
            $ref: '#/components/schemas/LocationValue'
          location-multi:
            $ref: '#/components/schemas/LocationsValue'
          person:
            $ref: '#/components/schemas/PersonValue'
          person-multi:
            $ref: '#/components/schemas/PersonsValue'
          ranked-dropdown:
            $ref: '#/components/schemas/RankedDropdownValue'
          text:
            $ref: '#/components/schemas/TextValue'
    CompaniesValue:
      title: CompaniesValue
      type: object
      properties:
        type:
          description: The type of value
          type: string
          const: company-multi
        data:
          description: The values for many companies
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/CompanyData'
          maxItems: 100
        totalCount:
          description: >-
            The total number of values for this field. When totalCount exceeds
            the length of data, additional values can be retrieved using the
            field values endpoint.
          type: integer
          format: int32
          minimum: 0
          maximum: 2147483647
      required:
        - data
        - type
      additionalProperties: false
      example:
        type: company-multi
        data:
          - id: 1
            name: Horizon Technologies
            domain: horizontech.com
          - id: 2
            name: Crestwood Capital
            domain: crestwoodcap.com
    CompanyValue:
      title: CompanyValue
      type: object
      properties:
        type:
          description: The type of value
          type: string
          const: company
        data:
          oneOf:
            - $ref: '#/components/schemas/CompanyData'
            - type: 'null'
      required:
        - data
        - type
      additionalProperties: false
      example:
        type: company
        data:
          id: 1
          name: Horizon Technologies
          domain: horizontech.com
    DateValue:
      title: DateValue
      type: object
      properties:
        type:
          description: The type of value
          type: string
          const: datetime
        data:
          description: The value for a date
          type:
            - string
            - 'null'
          format: date-time
      required:
        - data
        - type
      additionalProperties: false
      example:
        type: datetime
        data: '2023-01-01T00:00:00Z'
    DropdownsValue:
      title: DropdownsValue
      type: object
      properties:
        type:
          description: The type of value
          type: string
          const: dropdown-multi
        data:
          description: The value for many dropdown items
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/Dropdown'
          maxItems: 100
        totalCount:
          description: >-
            The total number of values for this field. When totalCount exceeds
            the length of data, additional values can be retrieved using the
            field values endpoint.
          type: integer
          format: int32
          minimum: 0
          maximum: 2147483647
      required:
        - data
        - type
      additionalProperties: false
      example:
        type: dropdown-multi
        data:
          - dropdownOptionId: 1
            text: Option 1
          - dropdownOptionId: 2
            text: Option 2
    DropdownValue:
      title: DropdownValue
      type: object
      properties:
        type:
          description: The type of value
          type: string
          const: dropdown
        data:
          oneOf:
            - $ref: '#/components/schemas/Dropdown'
            - type: 'null'
      required:
        - data
        - type
      additionalProperties: false
      example:
        type: dropdown
        data:
          dropdownOptionId: 1
          text: Option 1
    FloatsValue:
      title: FloatsValue
      type: object
      properties:
        type:
          description: The type of value
          type: string
          const: number-multi
        data:
          description: The value for many numbers
          type:
            - array
            - 'null'
          items:
            type: number
          maxItems: 100
        totalCount:
          description: >-
            The total number of values for this field. When totalCount exceeds
            the length of data, additional values can be retrieved using the
            field values endpoint.
          type: integer
          format: int32
          minimum: 0
          maximum: 2147483647
      required:
        - data
        - type
      additionalProperties: false
      example:
        type: number-multi
        data:
          - 100
          - 200
          - 300
    FloatValue:
      title: FloatValue
      type: object
      properties:
        type:
          description: The type of value
          type: string
          const: number
        data:
          description: The value for a number
          type:
            - number
            - 'null'
      required:
        - data
        - type
      additionalProperties: false
      example:
        type: number
        data: 100
    FormulaValue:
      title: FormulaValue
      type: object
      properties:
        type:
          description: The type of value
          type: string
          const: formula-number
        data:
          oneOf:
            - $ref: '#/components/schemas/FormulaNumber'
            - type: 'null'
      required:
        - data
        - type
      additionalProperties: false
      example:
        type: formula-number
        data:
          calculatedValue: 100
    InteractionValue:
      title: InteractionValue
      type: object
      properties:
        type:
          description: The type of value
          type: string
          const: interaction
        data:
          oneOf:
            - $ref: '#/components/schemas/Interaction'
            - type: 'null'
      required:
        - data
        - type
      additionalProperties: false
      example:
        type: interaction
        data:
          id: 1
          type: meeting
          title: Defective Products
          allDay: false
          startTime: '2020-01-02T00:00:00Z'
          endTime: '2020-01-02T01:00:00Z'
          attendees:
            - emailAddress: alex.rivera@horizontech.com
              person:
                id: 1
                firstName: Alex
                lastName: Rivera
                primaryEmailAddress: alex.rivera@horizontech.com
                type: internal
            - emailAddress: jordan.lee@crestwoodcap.com
              person:
                id: 2
                firstName: Jordan
                lastName: Lee
                primaryEmailAddress: jordan.lee@crestwoodcap.com
                type: external
    LocationsValue:
      title: LocationsValue
      type: object
      properties:
        type:
          description: The type of value
          type: string
          const: location-multi
        data:
          description: The values for many locations
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/Location'
          maxItems: 100
        totalCount:
          description: >-
            The total number of values for this field. When totalCount exceeds
            the length of data, additional values can be retrieved using the
            field values endpoint.
          type: integer
          format: int32
          minimum: 0
          maximum: 2147483647
      required:
        - data
        - type
      additionalProperties: false
      example:
        type: location-multi
        data:
          - streetAddress: 1 Main Street
            city: San Francisco
            state: California
            country: United States
            continent: North America
          - streetAddress: 1600 Pennsylvania Avenue NW
            city: Washington
            state: DC
            country: United States
            continent: North America
    LocationValue:
      title: LocationValue
      type: object
      properties:
        type:
          description: The type of value
          type: string
          const: location
        data:
          oneOf:
            - $ref: '#/components/schemas/Location'
            - type: 'null'
      required:
        - data
        - type
      additionalProperties: false
      example:
        type: location
        data:
          streetAddress: 1 Main Street
          city: San Francisco
          state: California
          country: United States
          continent: North America
    PersonsValue:
      title: PersonsValue
      type: object
      properties:
        type:
          description: The type of value
          type: string
          const: person-multi
        data:
          description: The values for many persons
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/PersonData'
          maxItems: 100
        totalCount:
          description: >-
            The total number of values for this field. When totalCount exceeds
            the length of data, additional values can be retrieved using the
            field values endpoint.
          type: integer
          format: int32
          minimum: 0
          maximum: 2147483647
      required:
        - data
        - type
      additionalProperties: false
      example:
        type: person-multi
        data:
          - id: 1
            firstName: Alex
            lastName: Rivera
            primaryEmailAddress: alex.rivera@horizontech.com
            type: internal
          - id: 2
            firstName: Jordan
            lastName: Lee
            primaryEmailAddress: jordan.lee@crestwoodcap.com
            type: external
    PersonValue:
      title: PersonValue
      type: object
      properties:
        type:
          description: The type of value
          type: string
          const: person
        data:
          oneOf:
            - $ref: '#/components/schemas/PersonData'
            - type: 'null'
      required:
        - data
        - type
      additionalProperties: false
      example:
        type: person
        data:
          id: 1
          firstName: Alex
          lastName: Rivera
          primaryEmailAddress: alex.rivera@horizontech.com
          type: internal
    RankedDropdownValue:
      title: RankedDropdownValue
      type: object
      properties:
        type:
          description: The type of value
          type: string
          const: ranked-dropdown
        data:
          oneOf:
            - $ref: '#/components/schemas/RankedDropdown'
            - type: 'null'
      required:
        - data
        - type
      additionalProperties: false
      example:
        type: ranked-dropdown
        data:
          dropdownOptionId: 1
          text: Option 1
          rank: 1
          color: gray
    TextsValue:
      title: TextsValue
      type: object
      properties:
        type:
          description: The type of value
          type: string
          const: filterable-text-multi
        data:
          description: The value for many strings
          type:
            - array
            - 'null'
          items:
            type: string
          maxItems: 100
        totalCount:
          description: >-
            The total number of values for this field. When totalCount exceeds
            the length of data, additional values can be retrieved using the
            field values endpoint.
          type: integer
          format: int32
          minimum: 0
          maximum: 2147483647
      required:
        - data
        - type
      additionalProperties: false
      example:
        type: filterable-text-multi
        data:
          - A text value
          - Another text value
    TextValue:
      title: TextValue
      type: object
      properties:
        type:
          description: The type of value
          type: string
          enum:
            - filterable-text
            - text
          example: filterable-text
        data:
          description: The value for a string
          type:
            - string
            - 'null'
      required:
        - data
        - type
      additionalProperties: false
      example:
        type: text
        data: Some new text
    CompanyData:
      title: CompanyData
      type: object
      properties:
        id:
          description: The company's unique identifier
          type: integer
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        name:
          description: The company's name
          type: string
          example: Horizon Technologies
        domain:
          description: The company's primary domain
          type:
            - string
            - 'null'
          format: hostname
          example: horizontech.com
      required:
        - domain
        - id
        - name
      additionalProperties: false
    Dropdown:
      title: Dropdown
      type: object
      properties:
        dropdownOptionId:
          description: Dropdown item's unique identifier
          type: integer
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        text:
          description: Dropdown item text
          type: string
          example: first
      required:
        - dropdownOptionId
        - text
      additionalProperties: false
    FormulaNumber:
      title: FormulaNumber
      type: object
      properties:
        calculatedValue:
          description: Calculated value
          type:
            - number
            - 'null'
      additionalProperties: false
    Interaction:
      title: Interaction
      oneOf:
        - $ref: '#/components/schemas/ChatMessage'
        - $ref: '#/components/schemas/Email'
        - $ref: '#/components/schemas/Meeting'
        - $ref: '#/components/schemas/PhoneCall'
      discriminator:
        propertyName: type
        mapping:
          chat-message:
            $ref: '#/components/schemas/ChatMessage'
          email:
            $ref: '#/components/schemas/Email'
          meeting:
            $ref: '#/components/schemas/Meeting'
          call:
            $ref: '#/components/schemas/PhoneCall'
    Location:
      title: Location
      type: object
      properties:
        streetAddress:
          description: Street address
          type:
            - string
            - 'null'
          example: 1 Main Street
        city:
          description: City
          type:
            - string
            - 'null'
          example: San Francisco
        state:
          description: State
          type:
            - string
            - 'null'
          example: California
        country:
          description: Country
          type:
            - string
            - 'null'
          example: United States
        continent:
          description: Continent
          type:
            - string
            - 'null'
          example: North America
      required:
        - city
        - continent
        - country
        - state
        - streetAddress
      additionalProperties: false
    PersonData:
      title: PersonData
      type: object
      properties:
        id:
          description: The persons's unique identifier
          type: integer
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        firstName:
          description: The person's first name
          type:
            - string
            - 'null'
          example: Jane
        lastName:
          description: The person's last name
          type:
            - string
            - 'null'
          example: Doe
        primaryEmailAddress:
          description: The person's primary email address
          type:
            - string
            - 'null'
          format: email
          example: jane.smith@northpointvc.com
        type:
          description: >-
            The person's type. `internal` - people who are users within your
            Affinity instance. `collaborator` - individuals outside of your
            company who have read-only access to specified Affinity list views
            and stay updated on your firm's activities. `external` - people who
            are not internal nor collaborators.
          type: string
          enum:
            - internal
            - collaborator
            - external
          example: internal
      required:
        - firstName
        - id
        - lastName
        - primaryEmailAddress
        - type
      additionalProperties: false
    RankedDropdown:
      title: RankedDropdown
      type: object
      properties:
        dropdownOptionId:
          description: Dropdown item's unique identifier
          type: integer
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        text:
          description: Dropdown item text
          type: string
          example: first
        rank:
          description: Dropdown item rank
          type: integer
          format: int64
          minimum: 0
          maximum: 9007199254740991
          example: 0
        color:
          description: Dropdown item color
          type:
            - string
            - 'null'
          example: white
      required:
        - color
        - dropdownOptionId
        - rank
        - text
      additionalProperties: false
    ChatMessage:
      title: ChatMessage
      type: object
      properties:
        type:
          description: The type of interaction
          type: string
          const: chat-message
          example: chat-message
        id:
          description: The chat message's unique identifier
          type: integer
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        direction:
          description: The direction of the chat message
          type: string
          enum:
            - received
            - sent
          example: sent
        sentAt:
          description: The time the chat message was sent
          type: string
          format: date-time
          example: '2023-01-01T00:00:00Z'
        manualCreator:
          $ref: '#/components/schemas/PersonData'
        participants:
          description: The participants of the chat
          type: array
          items:
            $ref: '#/components/schemas/PersonData'
      required:
        - direction
        - id
        - manualCreator
        - participants
        - sentAt
        - type
      additionalProperties: false
      example:
        type: chat-message
        id: 1
        direction: sent
        sentAt: '2023-01-01T00:00:00Z'
        manualCreator:
          id: 1
          firstName: Alex
          lastName: Rivera
          primaryEmailAddress: alex.rivera@horizontech.com
          type: internal
        participants:
          - id: 2
            firstName: Jordan
            lastName: Lee
            primaryEmailAddress: jordan.lee@crestwoodcap.com
            type: external
    Email:
      title: Email
      type: object
      properties:
        type:
          description: The type of interaction
          type: string
          const: email
          example: email
        id:
          description: The email's unique identifier
          type: integer
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        subject:
          description: The subject of the email
          type:
            - string
            - 'null'
          example: Horizon Technologies Upsell $10k
        sentAt:
          description: The time the email was sent
          type: string
          format: date-time
          example: '2023-01-01T00:00:00Z'
        from:
          $ref: '#/components/schemas/Attendee'
        to:
          description: The recipients of the email
          type: array
          items:
            $ref: '#/components/schemas/Attendee'
        cc:
          description: The cc recipients of the email
          type: array
          items:
            $ref: '#/components/schemas/Attendee'
      required:
        - cc
        - from
        - id
        - sentAt
        - subject
        - to
        - type
      additionalProperties: false
      example:
        type: email
        id: 1
        subject: Horizon Technologies Upsell $10k
        sentAt: '2023-01-01T00:00:00Z'
        from:
          emailAddress: alex.rivera@horizontech.com
          person:
            id: 1
            firstName: Alex
            lastName: Rivera
            primaryEmailAddress: alex.rivera@horizontech.com
            type: internal
        to:
          - emailAddress: jordan.lee@crestwoodcap.com
            person:
              id: 2
              firstName: Jordan
              lastName: Lee
              primaryEmailAddress: jordan.lee@crestwoodcap.com
              type: external
        cc: []
    Meeting:
      title: Meeting
      type: object
      properties:
        type:
          description: The type of interaction
          type: string
          const: meeting
          example: meeting
        id:
          description: The meeting's unique identifier
          type: integer
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        title:
          description: The meeting's title
          type:
            - string
            - 'null'
          example: Horizon Technologies Upsell $10k
        allDay:
          description: Whether the meeting is an all-day event
          type: boolean
          example: false
        startTime:
          description: The meeting start time
          type: string
          format: date-time
          example: '2023-02-03T04:00:00Z'
        endTime:
          description: The meeting end time
          type:
            - string
            - 'null'
          format: date-time
          example: '2023-02-03T05:00:00Z'
        attendees:
          description: People attending the meeting
          type: array
          items:
            $ref: '#/components/schemas/Attendee'
      required:
        - allDay
        - attendees
        - endTime
        - id
        - startTime
        - title
        - type
      additionalProperties: false
      example:
        type: meeting
        id: 1
        title: Defective Products
        allDay: false
        startTime: '2020-01-02T00:00:00Z'
        endTime: '2020-01-02T01:00:00Z'
        attendees:
          - emailAddress: alex.rivera@horizontech.com
            person:
              id: 1
              firstName: Alex
              lastName: Rivera
              primaryEmailAddress: alex.rivera@horizontech.com
              type: internal
          - emailAddress: jordan.lee@crestwoodcap.com
            person:
              id: 2
              firstName: Jordan
              lastName: Lee
              primaryEmailAddress: jordan.lee@crestwoodcap.com
              type: external
    PhoneCall:
      title: PhoneCall
      type: object
      properties:
        type:
          description: The type of interaction
          type: string
          const: call
          example: call
        id:
          description: The phone call's unique identifier
          type: integer
          format: int64
          minimum: 1
          maximum: 9007199254740991
          example: 1
        startTime:
          description: The call start time
          type: string
          format: date-time
          example: '2023-02-03T04:00:00Z'
        attendees:
          description: People attending the call
          type: array
          items:
            $ref: '#/components/schemas/Attendee'
      required:
        - attendees
        - id
        - startTime
        - type
      additionalProperties: false
      example:
        type: call
        id: 1
        startTime: '2023-02-03T04:00:00Z'
        attendees:
          - emailAddress: alex.rivera@horizontech.com
            person:
              id: 1
              firstName: Alex
              lastName: Rivera
              primaryEmailAddress: alex.rivera@horizontech.com
              type: internal
    Attendee:
      title: Attendee
      type: object
      properties:
        emailAddress:
          description: The email addresses of the attendee
          type:
            - string
            - 'null'
          format: email
          example: john.smith@contoso.com
        person:
          oneOf:
            - $ref: '#/components/schemas/PersonData'
            - type: 'null'
      required:
        - emailAddress
        - person
      additionalProperties: false
  headers:
    X-Ratelimit-Limit-User:
      description: Number of requests allowed per minute for the user
      schema:
        type: integer
    X-Ratelimit-Limit-User-Remaining:
      description: Number of requests remaining for the user
      schema:
        type: integer
    X-Ratelimit-Limit-User-Reset:
      description: Time in seconds before the limit resets for the user
      schema:
        type: integer
    X-Ratelimit-Limit-Org:
      description: Number of requests allowed per month for the account
      schema:
        type: integer
    X-Ratelimit-Limit-Org-Remaining:
      description: Number of requests remaining for the account
      schema:
        type: integer
    X-Ratelimit-Limit-Org-Reset:
      description: Time in seconds before the limit resets for the account
      schema:
        type: integer
  responses:
    '400':
      description: Bad Request
      content:
        application/json:
          schema:
            title: responses.400
            type: object
            properties:
              errors:
                type: array
                items:
                  oneOf:
                    - $ref: '#/components/schemas/BadRequestError'
                    - $ref: '#/components/schemas/ValidationError'
                  discriminator:
                    propertyName: code
                    mapping:
                      bad-request:
                        $ref: '#/components/schemas/BadRequestError'
                      validation:
                        $ref: '#/components/schemas/ValidationError'
            required:
              - errors
            additionalProperties: false
      headers:
        x-ratelimit-limit-user:
          $ref: '#/components/headers/X-Ratelimit-Limit-User'
        x-ratelimit-limit-user-remaining:
          $ref: '#/components/headers/X-Ratelimit-Limit-User-Remaining'
        x-ratelimit-limit-user-reset:
          $ref: '#/components/headers/X-Ratelimit-Limit-User-Reset'
        x-ratelimit-limit-org:
          $ref: '#/components/headers/X-Ratelimit-Limit-Org'
        x-ratelimit-limit-org-remaining:
          $ref: '#/components/headers/X-Ratelimit-Limit-Org-Remaining'
        x-ratelimit-limit-org-reset:
          $ref: '#/components/headers/X-Ratelimit-Limit-Org-Reset'
    '403':
      description: Forbidden
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/AuthorizationErrors'
      headers:
        x-ratelimit-limit-user:
          $ref: '#/components/headers/X-Ratelimit-Limit-User'
        x-ratelimit-limit-user-remaining:
          $ref: '#/components/headers/X-Ratelimit-Limit-User-Remaining'
        x-ratelimit-limit-user-reset:
          $ref: '#/components/headers/X-Ratelimit-Limit-User-Reset'
        x-ratelimit-limit-org:
          $ref: '#/components/headers/X-Ratelimit-Limit-Org'
        x-ratelimit-limit-org-remaining:
          $ref: '#/components/headers/X-Ratelimit-Limit-Org-Remaining'
        x-ratelimit-limit-org-reset:
          $ref: '#/components/headers/X-Ratelimit-Limit-Org-Reset'
    '404':
      description: Not Found
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/NotFoundErrors'
      headers:
        x-ratelimit-limit-user:
          $ref: '#/components/headers/X-Ratelimit-Limit-User'
        x-ratelimit-limit-user-remaining:
          $ref: '#/components/headers/X-Ratelimit-Limit-User-Remaining'
        x-ratelimit-limit-user-reset:
          $ref: '#/components/headers/X-Ratelimit-Limit-User-Reset'
        x-ratelimit-limit-org:
          $ref: '#/components/headers/X-Ratelimit-Limit-Org'
        x-ratelimit-limit-org-remaining:
          $ref: '#/components/headers/X-Ratelimit-Limit-Org-Remaining'
        x-ratelimit-limit-org-reset:
          $ref: '#/components/headers/X-Ratelimit-Limit-Org-Reset'
    default:
      description: Errors
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Errors'
      headers:
        x-ratelimit-limit-user:
          $ref: '#/components/headers/X-Ratelimit-Limit-User'
        x-ratelimit-limit-user-remaining:
          $ref: '#/components/headers/X-Ratelimit-Limit-User-Remaining'
        x-ratelimit-limit-user-reset:
          $ref: '#/components/headers/X-Ratelimit-Limit-User-Reset'
        x-ratelimit-limit-org:
          $ref: '#/components/headers/X-Ratelimit-Limit-Org'
        x-ratelimit-limit-org-remaining:
          $ref: '#/components/headers/X-Ratelimit-Limit-Org-Remaining'
        x-ratelimit-limit-org-reset:
          $ref: '#/components/headers/X-Ratelimit-Limit-Org-Reset'
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````